/***************************************************************************
 * U. Minnesota LPD Software * Copyright 1987, 1988, Patrick Powell
 ***************************************************************************
 * MODULE:  hpf.c
 ***************************************************************************
 * Revision History: Created Fri Mar  4 19:05:43 CST 1988
 * $Log:	hpf.c,v $
 * Revision 2.2  88/05/19  07:35:38  papowell
 * fixed minor bug with overstrikes
 * 
 * Revision 2.1  88/05/09  10:12:08  papowell
 * *** empty log message ***
 * 
 ***************************************************************************/
#ifndef lint
static char id_str1[] =
	"$Header: hpf.c,v 2.2 88/05/19 07:35:38 papowell Locked $ PLP Copyright 1988 Patrick Powell";
#endif lint
/***************************************************************************
 *	LPF and VPF filters.
 * 	Filter which converts lines with ^H's to overwritten lines.
 *	Thus this works like 'ul' but is much better; it can handle
 *	more than 2 overwrites and it is written with some style.
 *
 *	Also used as the versatec driver, with the VERSATEC defined
 *  Original source for this was the 4.2BSD release,  but there have
 *	been substantial modifications since.  This version has been derived 
 *	from a total rewrite done in 1985.
 ***************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <termio.h>

extern int errorcode;
/* set from flags */
extern int debug, width, length, xwidth, ylength, literal, indent, special;
extern char *zopts, *class, *job, *login, *accntname, *host, *accntfile;
extern char *printer, *format, *name;
extern int npages;	/* number of pages */
extern char *calloc();	/* memory allocation */

/* line printer */

#define MAXREP		10

#define	TIMEOUT		(5*60)	/*	5 minute time out	*/

char	*buf;
int	*maxcol;
int	lineno;
int ffsent;
extern int verbose;
struct termio oldtty, newtty;
char buffer[BUFSIZ];


int	timeout();

filter(stop)
	char *stop;
{
	register FILE *p = stdin, *o = stdout;
	int	ch;
	int flag;
	int numchars;

	/*ioctl(fileno(o), TCGETA, &oldtty);
	newtty = oldtty;
	newtty.c_oflag = 0;
	ioctl(fileno(o), TCSETAW, &newtty);*/

	/*
	 * set up timeout
	 */

	(void)alarm( TIMEOUT );	/* set up timeout */
	printf("\033E");	/* Reset the printer */
	(void)alarm( 0 );

	do {
		numchars = fread(buffer, sizeof(char), BUFSIZ, p);
		if (numchars > 0) {
			(void)alarm( TIMEOUT );	/* set up timeout */
			fwrite(buffer, sizeof(char), numchars, o);
			(void)alarm( 0 );
		}
	} while (numchars == BUFSIZ);
		
	(void)alarm( TIMEOUT );	/* set up timeout */
	(void)fflush( o );
	(void)alarm( 0 );
	if( ferror(o) ){
		logerr_die( "write failed" );
	}
	npages = 1;
	ioctl(fileno(o), TCSBRK, 1); /* drain tty-output */
}


timeout()
    {
	fatal( "timeout" );
    }

/*
 * do nothing on cleanup
 */

cleanup()
    {}
